//+------------------------------------------------------------------+
//|                                                         pCCI.mq5 |
//|                                                        AIS Forex |
//|                        https://www.mql5.com/en/users/aleksej1966 |
//+------------------------------------------------------------------+
#property copyright "AIS Forex"
#property link      "https://www.mql5.com/en/users/aleksej1966"
#property version   "1.00"
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_plots   1

#property indicator_level1 0
#property indicator_level2 0
#property indicator_levelcolor clrGray
#property indicator_levelstyle STYLE_DOT
#property indicator_levelwidth 1

#property indicator_applied_price PRICE_TYPICAL
#property indicator_type1  DRAW_LINE
#property indicator_label1 "pCCI"
#property indicator_color1 clrBlue
#property indicator_width1 1
#property indicator_style1 STYLE_SOLID

enum type_ind {Classical,Square,Modern};
input type_ind TypeInd=Classical;
input ushort iPeriod=14;
input uchar iLevel=70;

int indx10,indx11,indx20,indx21,level=1;
double buffer[],halfsums[],diff[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   if(iPeriod<2)
     {
      Alert("Minimum iPeriod = 2");
      return(INIT_FAILED);
     }
//--- indicator buffers mapping
   SetIndexBuffer(0,buffer,INDICATOR_DATA);
   ArraySetAsSeries(buffer,true);
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);

   if(TypeInd==Modern)
     {
      int size=iPeriod*(iPeriod-1)/2;
      ArrayResize(halfsums,size);
      indx10=size/2;
      indx11=MathMod(size,2)==0? indx10-1:indx10;

      ArrayResize(diff,iPeriod);
      indx20=iPeriod/2;
      indx21=MathMod(iPeriod,2)==0? indx20-1:indx20;
     }

   level=(uchar)MathMin(MathMax(iLevel,level),99);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
//---
   ArraySetAsSeries(price,true);

   static int array_dn[],size_dn,array_up[],size_up;
   int bars=rates_total-prev_calculated;

   if(prev_calculated==0)
     {
      bars=rates_total-iPeriod-1;
      ArrayResize(array_up,size_up,rates_total);
      ArrayResize(array_dn,size_dn,rates_total);
     }

   for(int i=bars; i>=0; i--)
     {
      double cci=0;
      if(TypeInd==Classical)
        {
         double mean=0,stdev=0;
         for(int j=0; j<iPeriod; j++)
            mean=mean+price[i+j];
         mean=mean/iPeriod;
         for(int j=0; j<iPeriod; j++)
            stdev=stdev+MathAbs(price[i+j]-mean);
         cci=price[i]>=mean? MathSqrt((price[i]-mean)*stdev/iPeriod):-MathSqrt((mean-price[i])*stdev/iPeriod);
        }

      if(TypeInd==Square)
        {
         double sumS=0,sumQ=0;
         for(int j=0; j<iPeriod; j++)
           {
            double p=price[i+j];
            sumS=sumS+p;
            sumQ=sumQ+p*p;
           }
         double mean=sumS/iPeriod,stdev=MathSqrt(iPeriod*sumQ-sumS*sumS)/iPeriod;
         cci=price[i]>=mean? MathSqrt((price[i]-mean)*stdev):-MathSqrt((mean-price[i])*stdev);
        }

      if(TypeInd==Modern)
        {
         int cnt=0;
         for(int j=iPeriod-2; j>=0; j--)
           {
            double p=price[i+j];
            for(int k=iPeriod-1; k>j; k--)
              {
               halfsums[cnt]=p+price[i+k];
               cnt++;
              }
           }
         ArraySort(halfsums);
         double mean=(halfsums[indx10]+halfsums[indx11])/4;
         for(int j=0; j<iPeriod; j++)
            diff[j]=MathAbs(price[i+j]-mean);
         ArraySort(diff);
         double stdev=(diff[indx20]+diff[indx21])/2;
         cci=price[i]>=mean? MathSqrt((price[i]-mean)*stdev):-MathSqrt((mean-price[i])*stdev);
        }

      if(i>0)
        {
         if(cci>0)
           {
            ArrayResize(array_up,size_up+1);
            array_up[size_up]=(int)MathRound(cci/_Point);
            size_up++;
           }
         if(cci<0)
           {
            ArrayResize(array_dn,size_dn+1);
            array_dn[size_dn]=(int)MathRound(-cci/_Point);
            size_dn++;
           }

         if(i==1)
           {
            ArraySort(array_up);
            IndicatorSetDouble(INDICATOR_LEVELVALUE,0,array_up[size_up*level/100]*_Point);
            ArraySort(array_dn);
            IndicatorSetDouble(INDICATOR_LEVELVALUE,1,-array_dn[size_dn*level/100]*_Point);
           }
        }

      buffer[i]=cci;
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
